package czerwony.kapturek.jbspell;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;

import java.beans.*;
import java.util.*;
import java.lang.reflect.*;

import com.borland.primetime.ide.*;
import com.borland.jbuilder.viewer.*;
import com.borland.primetime.viewer.*;
import com.borland.jbuilder.node.*;
import com.borland.primetime.node.*;
import com.borland.primetime.editor.*;
import com.borland.primetime.properties.*;
import com.borland.primetime.actions.*;


public class SpellCheckerTool
{
    private static SpellCheckerTool I;
    private static AbstractChecker  checker;
    private static Hashtable        checkers = new Hashtable();

    private Actions actions;

    public static void initOpenTool( byte major, byte minor )
    {
        I = new SpellCheckerTool();
    }

    public static void registerSpellCheckerImpl(String name, String className, Object configTopic)
    {
        Object[] checkerData = new Object[2];
        checkerData[0] = className;
        checkerData[1] = configTopic;
        checkers.put(name, checkerData);
    }

    static String[] getSpellCheckerImplementations()
    {
        return (String[])checkers.keySet().toArray(new String[0]);
    }

//    static String getSpellCheckerClass(String name)
//    {
//        return ((String[])checkers.get(name))[0];
//    }

    static Object getSpellCheckerConfigTopic(String name)
    {
        return ((Object[])checkers.get(name))[1];
    }

    public SpellCheckerTool()
    {
        printWelcomeMessage();
        initActions();
        initMenu();
    }


    private void printWelcomeMessage()
    {
        System.out.println(
            "**********************************************************************\n" +
            "**  Initializing: jbSpell (v0.20)                                   **\n" +
            "**                by Czerwony Kapturek (czerwony.kapturek@wp.pl)    **\n" +
            "**********************************************************************"
        );
    }

    private void addBoolOption(String key, String name, boolean def)
    {
        //EditorManager.registerEditorOption(new BooleanEditorOption(key, optionCategory, name, def));
    }


    static AbstractChecker getChecker()
    {
        if ((checker == null) || Settings.restartImpl)
        {
            try
            {
                if (checker != null)
                {
                    checker.unload();
                }
                String name = Settings.pluginName.getValue();
                if (name.length() == 0)
                {
                    name = (String)checkers.keys().nextElement();
                }
                String className = (String)((Object[])checkers.get(name))[0];
                Class checkerClass = Class.forName(className);
                Class[] argTypes = new Class[0];
                Method m = checkerClass.getMethod("getInstance", argTypes);
                Object[] args = new Object[0];
                checker = (AbstractChecker)m.invoke(null, args);
                Settings.restartImpl = false;
            }
            catch (Exception ex)
            {
                ex.printStackTrace();
                MessageBox.showMessage(Browser.getActiveBrowser(),
                                       "Cannot start spell checker - check configuration.", false);
                PropertyManager.showPropertyDialog(Browser.getActiveBrowser(), "",
                                                   EditorManager.EDITOR_TOPIC,
                                                   Settings.TXT_PAGE_NAME);
            }
        }
        return checker;
    }


    private void initActions()
    {
        actions = new Actions();
        EditorAction[] a = actions.getActions();
        for (int i = 0; i < a.length; i++)
        {
            EditorActions.addBindableEditorAction(a[i]);
        }
    }

    /** Add to JBuilder menu action for configuring jbSpell tool. */
    private void initMenu()
    {
        Icon iconSpell = new ImageIcon(getClass().getResource("spell.gif"));
        PropertyManager.registerPropertyGroup(new Settings());

        ActionGroup ag0 = new ActionGroup("akc", 'y', "qqqqqqqqqq", iconSpell, false);
        ActionGroup ag = new ActionGroup("Spell checker", 'c',
                                        "Spell checker related actions.", iconSpell, true);
        BrowserAction a = new BrowserAction("Check spelling in current file", 'c',
                                        "Check spelling in currently opened file.", iconSpell)
            {
                public void actionPerformed(Browser b)
                {
                    Actions.ACTION_CheckFile.actionPerformed(null);
                }

                public void update(Browser b)
                {
                    super.update(b);
                    setEnabled(isTextNode);
                }
            };
        ag.add(a);
        Browser.addToolBarGroup(Browser.getToolBarGroupCount(), ag);
//        ag0.add(ag);
//        ag.setDefaultAction(0);

        Browser.addStaticBrowserListener(new MyBrowserListener());
    }

    private boolean isTextNode;

    private class MyBrowserListener extends BrowserAdapter
    {
        public void browserNodeActivated(Browser browser, Node node)
        {
            isTextNode = node instanceof TextFileNode;
//            if (node instanceof TextFileNode)
//            {
//                TextFileNode textNode = (TextFileNode)node;
//                textNode.
//            }
        }

        public void browserNodeClosed(Browser browser, Node node)
        {
            if (browser.getOpenNodeCount() == 0)
                isTextNode = false;
        }
    }
}